# Export Plugin
module.exports = (BasePlugin) ->
	# Define Relations Plugin
	class RelationsPlugin extends BasePlugin
		# Plugin Name
		name: 'relations'

		# Parsing all files has finished
		parseAfter: ({logger},next) ->
			# Requires
			balUtil = require('bal-util')

			# Prepare
			docpad = @docpad
			documents = docpad.documents
			logger.log 'debug', 'Generating relations'

			# Async
			tasks = new balUtil.Group (err) ->
				logger.log 'debug', 'Generated relations'
				next err

			# Find documents
			documents.find {}, (err,docs,length) ->
				return tasks.exit(err)  if err
				return tasks.exit()  unless length
				tasks.total = length
				docs.forEach (document) ->
					# Find related documents
					documents.find {tags:{'$in':document.tags}}, (err,relatedDocuments,relatedDocumentsLength) ->
						return tasks.exit err  if err
						return tasks.complete()  unless relatedDocumentsLength

						# Fetch
						relatedDocumentsArray = []
						relatedDocuments.sort (a,b) ->
							return a.tags.hasCount(document.tags) < b.tags.hasCount(document.tags)
						relatedDocuments.forEach (relatedDocument) ->
							return null  if document.url is relatedDocument.url
							relatedDocumentsArray.push relatedDocument

						# Save
						document.relatedDocuments = relatedDocumentsArray
						document.store()
						tasks.complete()
